// FP20 VFD Mock example program ///////////////////////////////////////////////////////////////////////////////////////
//
// Andrew Wyatt
// retrojdm.com
//
#include "Arduino.h"
#include "gu7000.h"
#include "hal/gu7000UartHal.h"

// The pins below are configured for an ATMEGA1284 in the "Standard" pinout.
#define VFD_BAUD_RATE 115200 // Default is 38400. See VFD Jumpers for more options.
#define PIN_VFD_SERIAL_RX 10  // Not actually used
#define PIN_VFD_SERIAL_TX 11  // This goes to the SIN pin on the VFD
#define PIN_VFD_SBUSY 12
#define PIN_VFD_RESET 13

// These values are for a GU112X16G-7003. You might need to change them for your own display.
#define VFD_DISPLAY_WIDTH 112 // px
#define VFD_DISPLAY_HEIGHT 16 // px
#define VFD_MEMORY_WIDTH 512  // px
#define VFD_MEMORY_HEIGHT 16  // px

// An instance of the gu7000UartHal class.
// This is a Hardware Abstraction layer for asynchronous serial (UART) mode.
// See gu7000I2cHal or write a custom HAL for other modes if your display supports them.
gu7000UartHal vfdHal(
    &Serial1,
    PIN_VFD_SBUSY,
    PIN_VFD_RESET);

// Error code "2" means we timed out waiting over 1 second for the SBusy pin to go LOW.
// This could occur if we didn't reset properly or if the read buffer is full.
static void errorCallback(uint8_t code)
{
    Serial.begin(9600);
    Serial.print("Error ");
    Serial.println(code);
    while (true)
        ;
}

// An instance of the gu7000 class.
gu7000 vfd(
    VFD_DISPLAY_WIDTH,
    VFD_DISPLAY_HEIGHT,
    VFD_MEMORY_WIDTH,
    VFD_MEMORY_HEIGHT,
    &vfdHal,
    errorCallback);


/*
You can generate sprites using either of the following tools:

    http://www.noritake-elec.com/codeLibraries/gu7000/gu7000_BitmapImageTool.html
    http://en.radzio.dxp.pl/bitmap_converter/
*/

/* 112 x 16 px */
static const byte mockMediaPlayerData[] = {
    0x7c, 0xf8, 0x51, 0x04, 0x41, 0x04, 0x01, 0x04, 0x7c, 0x88, 0x04, 0x00, 0x04, 0x38, 0x00, 0x44,
    0x38, 0x44, 0x44, 0x44, 0x38, 0x38, 0x00, 0x00, 0x7c, 0x20, 0x50, 0x54, 0x2c, 0x54, 0x00, 0x54,
    0x7c, 0x08, 0x54, 0x00, 0x44, 0x7c, 0x00, 0x40, 0x7c, 0x30, 0x20, 0x40, 0x7c, 0x3c, 0x00, 0x00,
    0x38, 0x00, 0x44, 0x00, 0x45, 0x7c, 0x00, 0x04, 0x7c, 0x00, 0x54, 0x00, 0x44, 0x38, 0x00, 0x44,
    0x00, 0x44, 0x00, 0x44, 0x00, 0x28, 0x00, 0x00, 0x3c, 0x00, 0x50, 0x00, 0x3c, 0x00, 0x00, 0x00,
    0x7c, 0x00, 0x20, 0x00, 0x7d, 0xfc, 0x00, 0x04, 0x7c, 0x04, 0x44, 0x04, 0x38, 0x04, 0x00, 0x00,
    0x00, 0x38, 0x00, 0x44, 0x00, 0x44, 0x00, 0x44, 0x40, 0x38, 0x7c, 0x00, 0x40, 0x70, 0x00, 0x08,
    0x7c, 0x04, 0x10, 0x08, 0x7c, 0x70, 0x00, 0x00, 0x7c, 0x38, 0x54, 0x54, 0x44, 0x54, 0x00, 0x54,
    0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x00, 0x30, 0x00, 0x7c, 0x00, 0x00, 0x00,
    0x3c, 0x00, 0x50, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x38, 0x00, 0x44, 0x00, 0x44, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x14, 0x0f, 0x07, 0xd1, 0x74, 0x1e,
    0x70, 0x00, 0x00, 0x09, 0x31, 0x5f, 0x30, 0x01, 0x00, 0x00, 0xf3, 0xc0, 0xf4, 0x45, 0x07, 0x80,
    0xf0, 0x00, 0xf3, 0xd3, 0x04, 0x55, 0x37, 0x89, 0x30, 0x00, 0x02, 0x51, 0x17, 0xd5, 0x10, 0x4a};

static const struct sprite mockMediaPlayer = {
    .width = 112,
    .height = 16,
    .xOffset = 0, // (x,y) handle
    .yOffset = 0,
    .data = mockMediaPlayerData};

void setup()
{
    // We need to begin the Serial before calling vfd.begin();
    pinMode(PIN_VFD_SERIAL_RX, INPUT);
    pinMode(PIN_VFD_SERIAL_TX, OUTPUT);
    Serial1.begin(VFD_BAUD_RATE);

    vfd.reset();
    vfd.init();

    vfd.brightness(8); // 1..8l+
    vfd.windowSelect(0);
    vfd.writeScreenMode(0);
    vfd.cls();

    // Blit with top-left of sprite at cursor position.
    vfd.setCursor(0, 0);
    vfd.blit(mockMediaPlayer);
}

void loop()
{
}
